//Based on
//http://blog.blprnt.com/blog/blprnt/processing-json-the-new-york-times

import org.json.*;
import java.net.URLEncoder;

//CIID Test API Key
String apiKey = "4c6dacad5823fc715f62d7519ba70771:16:65787462";
String baseURL = "http://api.nytimes.com/svc/search/v1/article";

int getArticlesInLast30Days(String searchTerm) {
  //oter possible parameters
  //&begin_date=19940101
  //&end_data=19960101  
  String request = baseURL + "?query=" + URLEncoder.encode(searchTerm) + "&more=past_30&api-key=" + apiKey;
  String[] resultArray = loadStrings( request );
  if (resultArray == null) {
    println ("There was no occurences of the term '" + searchTerm + "' in last 30 days");
    return 0;
  }
  String result = join(resultArray , "");
  
  int numTitlesToPrint = 5;
  
  try {
    JSONObject nytData = new JSONObject(join(loadStrings(request), ""));
    JSONArray results = nytData.getJSONArray("results");
    int total = nytData.getInt("total");
    println ("There were " + total + " occurences of the term '" + searchTerm + "' in last 30 days");
    for(int i=0; i<Math.min(numTitlesToPrint, total); i++) {
      JSONObject o = results.getJSONObject(i);
      println(" " + (i+1) + " : " + o.getString("title"));
    }
    if (total > numTitlesToPrint) {
      println(" ...");
    }
    println(" ");
    return total;
  }
  catch (JSONException e) {
    println ("There was an error parsing the JSONObject.");
  };
  return 0;
};

void setup() {
  getArticlesInLast30Days("copenhagen");
  getArticlesInLast30Days("denmark");  
  getArticlesInLast30Days("interaction design");
  getArticlesInLast30Days("CIID");
}

void draw() {
}
